// Persistence of Vision Ray Tracer Scene Description File
// File: rchar.pov
// Vers: 3.1
// Desc: Test rcinc.inc and rchar.inc
// Date: 25 May 2000
// Auth: Matthew Edd Tillman
//       e-mail: mrhorse@usa.net
//       www:    http://www.bigfoot.com/~special_edd

#version 3.1;
global_settings {assumed_gamma 1.0}

// ----------------------------------------
// ---------------INCLUDES-----------------
// ----------------------------------------
#include "rcinc.inc"
#include "colors.inc"
// ----------------------------------------
// --------------VARIABLES------------------
// ----------------------------------------

// ----------------------------------------
// --------------TEXTURES-----------------
// ----------------------------------------

// ----------------------------------------
// --------------OBJECTS------------------
// ----------------------------------------

// ----------------------------------------
// -----------SCENE SETUP------------------
// ----------------------------------------

camera
{
  location  <0, 1, -14>
  look_at   <0, 1,  0>
}

background {White}

light_source
{
  <-30,30,-30>
  White
  shadowless
}
light_source
{
  < 30,30,-30>
  White
  jitter
}

// ----------------------------------------
// -------------------SCENE----------------
// ----------------------------------------

RoundedChar ("mrhorse@usa.net",1)
object {Message pigment{ color Green*.6} scale <1,1,4>}
box {<-8,-1,0>,<8,2,2>
  pigment {
    gradient x
    color_map {
     [.2 color rgb <.2,.5,.5>]
     [.4 color rgb <.3,.9,.1>]
     [.6 color rgb <.1,.8,.1>]
     [.8 color rgb <.2,.6,.1>]
     [ 1 color rgb <.1,.7,.4>]
    }
    translate <20,0,0>
    turbulence .7
  
  }
}         
