// Persistence of Vision Ray Tracer Include File
// File: round.inc
// Vers: 3.1
// Desc: macro for rchar.inc
// Date: 25 May 2000
// Auth: Matthew Edd Tillman
//       e-mail: mrhorse@usa.net
//       www:    http://www.bigfoot.com/~special_edd
//
// Usage: #include "round.inc"
//        RoundedChar ("Text Goes Here",[0 or 1])
//           //use 1 to center text on the origin
//           //use 0 to put left side of text on the origin
//           //text front is on z=-.1, text back is on z=.1
//        object {Message ...}


#include "rchar.inc"
#macro RoundedChar (String,Centered)
#declare Message= 
union{
  #declare StringLength=strlen(String);
  #declare Count=1;
  #declare Shift=0;
  #while (Count<StringLength+1)
    #declare noletter=false;
    #declare Sub=substr(String,Count,1)
    #declare SubAscii=asc(Sub);
    //#warning str(SubAscii,2,0)
    #switch(SubAscii)
      #case(32)
        #declare noletter=true;
        #declare TempShift=1;
        #break
      #case(33)
        object {Rounded_Exc
        #declare TempShift=0.3;
        #break
      #case(34)
        object {Rounded_DQuote
        #declare TempShift=0.6;
        #break
      #case(35)
        object {Rounded_Pound
        #declare TempShift=1.1;
        #break
      #case(36)
        object {Rounded_Dollar
        #declare TempShift=.85;
        #break
      #case(37)
        object {Rounded_Percent
        #declare TempShift=1.1;
        #break
      #case(39)
        object {Rounded_SQuote
        #declare TempShift=.3;
        #break
        #break
      #case(40)
        #object {Rounded_OP
        #declare TempShift=.7;
        #break
      #case(41)
        #object {Rounded_CP
        #declare TempShift=.7;
        #break
      #case(42)
        #object {Rounded_Star
        #declare TempShift=.9;
        #break
      #case(43)
        #object {Rounded_Plus
        #declare TempShift=.9;
        #break
      #case(44)
        #object {Rounded_Comma
        #declare TempShift=.35;
        #break
      #case(45)
        #object {Rounded_Minus
        #declare TempShift=.9;
        #break
      #case(46)
        #object {Rounded_Period
        #declare TempShift=.3;
        #break
      #case(47)
        #object {Rounded_FSlash
        #declare TempShift=.6;
        #break
      #case(48)
        #object {Rounded_0
        #declare TempShift=1.1;
        #break
      #case(49)
        #object {Rounded_1
        #declare TempShift=.9;
        #break
      #case(50)
        #object {Rounded_2
        #declare TempShift=1;
        #break
      #case(51)
        #object {Rounded_3
        #declare TempShift=.95;
        #break
      #case(52)
        #object {Rounded_4
        #declare TempShift=1;
        #break
      #case(53)
        #object {Rounded_5
        #declare TempShift=.969;
        #break
      #case(54)
        #object {Rounded_6
        #declare TempShift=1;
        #break
      #case(55)
        #object {Rounded_7
        #declare TempShift=.9;
        #break
      #case(56)
        #object {Rounded_8
        #declare TempShift=.95;
        #break
      #case(57)
        #object {Rounded_9
        #declare TempShift=1;
        #break
      #case(58)
        #object {Rounded_Colon
        #declare TempShift=.4;
        #break
      #case(59)
        #object {Rounded_Semicolon
        #declare TempShift=.4;
        #break
      #case(60)
        #object {Rounded_LessThan
        #declare TempShift=1;
        #break
      #case(61)
        #object {Rounded_Equals
        #declare TempShift=1;
        #break
      #case(62)
        #object {Rounded_GrThan
        #declare TempShift=1;
        #break
      #case(63)
        #object {Rounded_Questionmark
        #declare TempShift=.8;
        #break
      #case(64)
        #object {Rounded_At
        #declare TempShift=1.35;
        #break             
      #case(65)
        object {Rounded_A 
        #declare TempShift=1.1;
        #break
      #case(66)
        object {Rounded_B
        #declare TempShift=1.0;
        #break
      #case(67)
        object {Rounded_C 
        #declare TempShift=1.1;
        #break
      #case(68)
        object {Rounded_D
        #declare TempShift=1.0;
        #break      
      #case(69)
        object {Rounded_E 
        #declare TempShift=1.0;
        #break
      #case(70)
        object {Rounded_F
        #declare TempShift=1.0;
        #break
      #case(71)
        object {Rounded_G 
        #declare TempShift=1.1;
        #break
      #case(72)
        object {Rounded_H
        #declare TempShift=.9;
        #break
      #case(73)
        object {Rounded_I 
        #declare TempShift=1.1;
        #break
      #case(74)
        object {Rounded_J
        #declare TempShift=.9;
        #break
      #case(75)
        object {Rounded_K 
        #declare TempShift=1.1;
        #break
      #case(76)
        object {Rounded_L
        #declare TempShift=1.0;
        #break
      #case(77)
        object {Rounded_M 
        #declare TempShift=1.1;
        #break
      #case(78)
        object {Rounded_N
        #declare TempShift=1.1;
        #break
      #case(79)
        object {Rounded_O 
        #declare TempShift=1.1;
        #break
      #case(80)
        object {Rounded_P
        #declare TempShift=1.0;
        #break
      #case(81)
        object {Rounded_Q 
        #declare TempShift=1.1;
        #break
      #case(82)
        object {Rounded_R
        #declare TempShift=.8;
        #break
      #case(83)
        object {Rounded_S 
        #declare TempShift=.9;
        #break
      #case(84)
        object {Rounded_T
        #declare TempShift=1.1;
        #break
      #case(85)
        object {Rounded_U 
        #declare TempShift=.9;
        #break
      #case(86)
        object {Rounded_V
        #declare TempShift=1.1;
        #break
      #case(87)
        object {Rounded_W 
        #declare TempShift=1.5;
        #break
      #case(88)
        object {Rounded_X
        #declare TempShift=1.1;
        #break
      #case(89)
        object {Rounded_Y 
        #declare TempShift=1.1;
        #break
      #case(90)
        object {Rounded_Z
        #declare TempShift=1.1;
        #break
      #case(91)
        object {Rounded_OB 
        #declare TempShift=.6;
        #break
      #case(92)
        object {Rounded_BSlash
        #declare TempShift=.6;
        #break
      #case(93)
        object {Rounded_CB
        #declare TempShift=.6;
        #break
      #case(94)
        object {Rounded_Carot 
        #declare TempShift=.9;
        #break
      #case(95)
        object {Rounded_Underscore
        #declare TempShift=1.0;
        #break
      #case(96)
        object {Rounded_Thing 
        #declare TempShift=.4;
        #break
      #case(97)
        object {Rounded_a 
        #declare TempShift=1.1;
        #break
      #case(98)
        object {Rounded_b
        #declare TempShift=1.1;
        #break
      #case(99)
        object {Rounded_c 
        #declare TempShift=1.0;
        #break
      #case(100)
        object {Rounded_d
        #declare TempShift=1.1;
        #break      
      #case(101)
        object {Rounded_e 
        #declare TempShift=1.1;
        #break
      #case(102)
        object {Rounded_f
        #declare TempShift=.9;
        #break
      #case(103)
        object {Rounded_g 
        #declare TempShift=1.1;
        #break
      #case(104)
        object {Rounded_h
        #declare TempShift=.9;
        #break
      #case(105)
        object {Rounded_i 
        #declare TempShift=.3;
        #break
      #case(106)
        object {Rounded_j
        #declare TempShift=.9;
        #break
      #case(107)
        object {Rounded_k 
        #declare TempShift=.9;
        #break
      #case(108)
        object {Rounded_l
        #declare TempShift=.3;
        #break
      #case(109)
        object {Rounded_m 
        #declare TempShift=1.1;
        #break
      #case(110)
        object {Rounded_n
        #declare TempShift=.9;
        #break
      #case(111)
        object {Rounded_o 
        #declare TempShift=1.1;
        #break
      #case(112)
        object {Rounded_p
        #declare TempShift=1.1;
        #break
      #case(113)
        object {Rounded_q 
        #declare TempShift=1.2;
        #break
      #case(114)
        object {Rounded_r
        #declare TempShift=.9;
        #break
      #case(115)
        object {Rounded_s 
        #declare TempShift=.7;
        #break
      #case(116)
        object {Rounded_t
        #declare TempShift=.9;
        #break
      #case(117)
        object {Rounded_u 
        #declare TempShift=.9;
        #break
      #case(118)
        object {Rounded_v
        #declare TempShift=1.1;
        #break
      #case(119)
        object {Rounded_w 
        #declare TempShift=1.5;
        #break
      #case(120)
        object {Rounded_x
        #declare TempShift=.9;
        #break
      #case(121)
        object {Rounded_y 
        #declare TempShift=.9;
        #break
      #case(122)
        object {Rounded_z
        #declare TempShift=1.0;
        #break
      #case(123)
        object{Rounded_OCB
        #declare TempShift=.7;
        #break
      #case(124)
        object{Rounded_Or
        #declare TempShift = .3;
        #break
      #case(125)
        object{Rounded_CCB
        #declare TempShift=.7;
        #break
      #case(126)
        object{Rounded_Atilda
        #declare TempShift=1.1;
        #break  
      #else
        #warning "Character Not Supported"
        #declare noletter=true;
        #break
      #end //end switch 
    
    #if(noletter) //nothing
    #else translate <Shift,0,0>}
    #end //end if
    #declare Shift=Shift+TempShift;

    #declare Count=Count+1;
  #end//end while
      #if (Centered = 1)
      translate <-(Shift/2)+.1,0,0>
      #end// end if
    } //end union
#end //end Macro